#!/bin/sh
#bu_VINRARUS 2018
LD_PRELOAD=
busybox_full (){
${0%/*}/busybox "$@"
}
INTERVAL="$((3600*3))"
ZONE="+2"
z_lang="auto"
SED=1
. ${0%/*}/Config.sh
LANGUST(){
if [ "$z_lang" = "auto" ]
then
    while read A B LANGS
    do
        if [ "$A" = "DefaultInputLang" ]
        then
            break
        fi
    done </ezxlocal/download/appwrite/setup/ezx_system.cfg
else
LANGS="$z_lang"
fi
if [ -f "${0%/*}/LANG/$LANGS.sh" ]
then
	export LANG="${0%/*}/LANG/$LANGS.sh"
else
	export LANG="${0%/*}/LANG/en-gb.sh"
	LANGS="en-gb"
fi
if [ ! -f "$LANG" ]
then
	showQ "LANG EROR!" "Not file: $LANG" 2
	exit
fi
OLDL="$z_lang"
}
LANGUST
. $LANG
if [ ! -d "${0%/*}/tmp" ]
then
    mkdir "${0%/*}/tmp"
    ${0%/*}/setting.sh START
    . ${0%/*}/Config.sh
fi
KOSTIL=1
for FILE in "${0%/*}/tmp/"*
do
    KOSTIL="$((KOSTIL+1))"
    read TAM < $FILE
    TUT="$TUT \"$TAM\""
done
eval showRadio "'zForecast 1.1'" "''" $TUT "\*$Lnastroy"
RADI=$?
if [ "$RADI" = 0 ]
then
    exit
elif [ "$RADI" = "$KOSTIL" ]
then
    echo setting
    ${0%/*}/setting.sh
    exit
fi
RAD=1
for FILE in "${0%/*}/tmp/"*
do
    if [ "$RADI" = "$RAD" ]
    then
        break
    else
        RAD=$((RAD+1))
    fi
done
CITY="${FILE##*/}"
CITY="${CITY%.*}"
POGODA="${0%/*}/tmp/$CITY.txt"
ZARAZ=`date "+%Y.%m.%d %H"`
    TODI=
    TODI2=1
    ZARAZ2=2
if [ -f "$POGODA" ]
then
    TODI=`date "+%Y.%m.%d %H:%M" -r "$POGODA"`
    TODI1=`date "+%s" -r "$POGODA"`
    TODI2="$((TODI1+$INTERVAL))"
    ZARAZ2=`date "+%s"`
fi
if [ 0 = "$INTERVAL" ]
then
    WAT(){
    showQ "zForecast" "$LupdateA" 1
    }
else
    WAT(){
    false
    }
fi
if [ ! -f "/ezxlocal/download/netexec" ]
then
    if ! showQ "zForecast EROR" "Netexec?" 0
    then
        exit
    fi
fi
if [ "${TODI%:*}" != "$ZARAZ" -a "$TODI2" -lt "$ZARAZ2" ]
then
    if WAT
    then
        showNotify "zForecast" "$Lauto" 1 1 &
    else
        if     `cat /ezxlocal/download/netexec` START
        then
        #   wget "http://api.openweathermap.org/data/2.5/forecast?id=$CITY&appid=489b47aa8eb421644b28d137d94d7625&mode=xml&units=metric&lang=uk" -O - | sed 's/<time /\n\n/g' > ${0%/*}/${CITY}1.txt
            busybox wget "http://api.openweathermap.org/data/2.5/forecast?id=$CITY&appid=489b47aa8eb421644b28d137d94d7625&mode=xml&units=metric&lang=$LANGS" -O - | sed -e "1d" -e "s/.*<location><name>//" -e "s/<\/name><type><\/type><country>/ /" -e "s/<\/country>.*<forecast>//" -e 's/</\n/g' > /tmp/zForecast.tmp
            `cat /ezxlocal/download/netexec` stop -s &
            if [ ! -f "$POGODA" ]
            then
                mv "$FILE" "$POGODA"
            fi
            TODI1="$ZARAZ2"
       else 
            showNotify "zForecast" "$Lauto" 1 1 &
        fi
    fi
fi
CLEAR(){
read a b c d e f z < /dev/null
read A B C D E F G H Z < /dev/null
DATA=
TIME=
POGODKA=
OPADN=
VITER=
VITERMS=
TEMPERATURA=
TNSK=
VOLOGIST=
HMARN=
TODI=
}
SED1(){
N=1
NN=1
TEXT=
while read S1 S2 S3
do
if [ "$S1" = "-----" ]
then
    eval "$1=\"$S2\""
    eval "N$NN=\"$N\""
    TEN="$NN"
    eval "TEXT$TEN="
    NN=$(($NN+1))
    shift
else
eval "eval \"TEXT$TEN=\\\"\$TEXT$TEN $S1 $S2 $S3
\\\"\""
fi
N=$(($N+1))
done < $POGODA
}
SED2(){
N=0
NN=0
TEXT=
while read S1 S2 S3
do
N="$(($N+1))"
if [ "$S1" = "-----" ]
then
    N=1
TEXT="$TEXT$S1 $S2 $S3
"
elif [ "$N" = "2" ]
then
    TXT1="$S2"
    TXT3="$S3"
elif [ "$N" = "3" ]
then
    TXT2="$S1"
elif [ "$N" = "6" ]
then
    N=1
TEXT="$TEXT$TXT1 $TXT2 $TXT3
"
fi
done < $POGODA
}
FILTER(){
read MISTO < /tmp/zForecast.tmp
if [ -n "$MISTO" ]
then
echo $MISTO > $POGODA 
IFSbak="$IFS"
IFS='"'
#date +%Y-%m-%d
#DATA=`date +%Y-%m-`
#sed -e "/from=/!d" -e 's/</\n/g' ${0%/*}/${CITY}1.txt > ${0%/*}/${CITY}2.txt
#sed -e "/from=\"$DATA/!d" -e 's/</\n/g' ${0%/*}/w1.txt | 
while read a b c d e f z
do
case  "$a" in
"time from=") #датаТчас
TIM="${b#*T0}"
TIM="${TIM#*T}"
TIM="${TIM%%:*}"
if [ -z "$STARTDAY" ]
then
    REAL=$(($ZONE*3600+`busybox_full date -d "${b%T*} $TIM" +%s`))
    STARTDAY=`busybox_full date -d "@$REAL" "+%w"`
    case "$STARTDAY" in
        1)
        shift;
        ;;
        2)
        shift; shift;
        ;;
        3)
        shift; shift; shift;
        ;;
        4)
        shift; shift; shift; shift;
        ;;
        5)
        shift; shift; shift; shift; shift;
        ;;
        6)
        shift; shift; shift; shift; shift; shift;
        ;;
        0)
        shift; shift; shift; shift; shift; shift; shift; 
        ;;
    esac
    echo "----- $1 -----"
    TIME=$(($ZONE+$TIM))
    OLD=0
fi
TIME=$(($ZONE+$TIM))
#echo =$TIME
if [ "$TIME" -lt 0 ]
then
    TIME=$((24$TIME))
elif [ "$TIME" -ge 24 ]
then
    TIME=$(($TIME-24))
fi
if [ "$TIME" -le "$OLD" ]
then
    shift
    echo "----- $1 -----"
fi
OLD=$TIME
DATA="$1"
#echo "$DAY $TIME:00 ($b)"
;;
"symbol number=") #погода в принципі
POGODKA="$d"
;;
"precipitation unit=") #опади
if [ ! -z "$f" ]
then
    OPADN=", $Lprecipitation"
fi
;;
"windDirection deg=") #напрямок вітру
VITER="$d"
;;
"windSpeed mps=") #швидкість вітру
VITERMS="${b%.*} m/s"
;;
"temperature unit=") #температура
TEMPERATURA="${d%.*}°C"
;;
"pressure unit=") #тиск
TNSK="${d%.*} $b"
;;
"humidity value=") #вологість
VOLOGIST="$b$d"
;;
"clouds value=") #стан хмар
HMARN="$d$f"
;;
"/time>")
TODI=$(($TIME+3))
if [ "$TODI" -ge "24" ]
then
    TODI=$(($TODI-24))
fi
echo "$DATA $TIME: $POGODKA
$TEMPERATURA, $Lhumidity $VOLOGIST
$LwindSpeed $VITERMS ($VITER)
$Lclouds $HMARN$OPADN
"
CLEAR
;;
esac
done < /tmp/zForecast.tmp >> $POGODA
IFS="$IFSbak"
fi
rm -f /tmp/zForecast.tmp
}
SHOW1(){
if [ -n "$H" ]
then
    MOD=9
    TED="$A-$H"
elif [ -n "$G" ]
then
    MOD=8
    TED="$A-$G"
elif [ -n "$F" ]
then
    MOD=7
    TED="$A-$F"
elif [ -n "$E" ]
then
    MOD=6
    TED="$A-$E"
else
    MOD=10
    TED=
fi
read NAME < $POGODA
showRadio "zForecast" "$NAME $TODI" $A $B $C $D $E $F $G $H "$TED"
RADIO=$?
if [ "$RADIO" = 0 ]
then
    exit
elif [ "$RADIO" = "$MOD" ]
then
    SED2
    SHOW2
else
    eval "DO=\$N$RADIO"
    eval "PISLYA=\$N$(($RADIO+1))"
    #showQ "zForecast" "`sed "1,${DO}d;$PISLYA,1000d" ${0%/*}/w3.txt`" 2
    eval "TEXT=\$TEXT$RADIO"
   if showQ "$NAME" "$TEXT" 0
   then
    SHOW1
   fi
fi
}
SHOW2(){
read NAME < $POGODA
if showQ "$NAME" "$TODI
$TEXT" 0
then
    SED1 A B C D E F G H Z
    SHOW1
else
    exit
fi
}
if [ -f /tmp/zForecast.tmp ]
then
    FILTER $DAYS
elif [ ! -f "$POGODA" ]
then
    showQ "zForecast EROR" "$LupdateC" 2
    exit
else
    if [ "$((TODI1+440000))" -lt "$ZARAZ2" ]
    then
        if ! showQ "zForecast" "$LupdateB" 0
        then
            exit
        fi
    fi
fi
if [ "$SED" = "2" ]
then
    SED2
    SHOW2
else
    SED1 A B C D E F G H Z
    SHOW1
fi
